# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DevSpaces::Mgmt::V2018_06_01_preview
  module Models
    #
    # Model object.
    #
    #
    class Controller < TrackedResource

      include MsRestAzure

      # @return [ProvisioningState] Provisioning state of the Azure Dev Spaces
      # Controller. Possible values include: 'Succeeded', 'Failed', 'Canceled',
      # 'Updating', 'Creating', 'Deleting'
      attr_accessor :provisioning_state

      # @return [String] DNS suffix for public endpoints running in the Azure
      # Dev Spaces Controller.
      attr_accessor :host_suffix

      # @return [String] DNS name for accessing DataPlane services
      attr_accessor :data_plane_fqdn

      # @return [String] Resource ID of the target container host
      attr_accessor :target_container_host_resource_id

      # @return [String] Credentials of the target container host (base64).
      attr_accessor :target_container_host_credentials_base64

      # @return [Sku]
      attr_accessor :sku


      #
      # Mapper for Controller class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Controller',
          type: {
            name: 'Composite',
            class_name: 'Controller',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              host_suffix: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.hostSuffix',
                type: {
                  name: 'String'
                }
              },
              data_plane_fqdn: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.dataPlaneFqdn',
                type: {
                  name: 'String'
                }
              },
              target_container_host_resource_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.targetContainerHostResourceId',
                type: {
                  name: 'String'
                }
              },
              target_container_host_credentials_base64: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.targetContainerHostCredentialsBase64',
                type: {
                  name: 'String'
                }
              },
              sku: {
                client_side_validation: true,
                required: true,
                serialized_name: 'sku',
                default_value: {},
                type: {
                  name: 'Composite',
                  class_name: 'Sku'
                }
              }
            }
          }
        }
      end
    end
  end
end
